



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[转载]WebBrowser控件表单（form）的自动填写和提交</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[转载]WebBrowser控件表单（form）的自动填写和提交</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 18:29:54 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>话说有了WebBrowser类，终于不用自己手动封装SHDocVw的AxWebBrowser这个ActiveX控件了。这个类如果仅仅作为一个和IE一模一样浏览器，那就太没意思了（还不如直接用IE呢）。那么，无论我们是想做一个&ldquo;定制版IE&rdquo;，还是希望利用HTML来做用户界面（指WinApp而非WebApp。许多单机软件，包括Windows的帮助支持中心，都是HTML做的），都少不了Windows Form和包含在WebBrowser中的Web页面的交互。本文将通过几个实际的例子，初步介绍一下WinForm和WebBrowser所包含的Web页面之间的交互。</p>
<p>下面的代码假设你已经建立了一个Windows Form，上面有一个WebBrowser名为&ldquo;webBrowser&rdquo;。</p>
<p><strong>Study Case 1：用WinForm的Event Handler响应Web页面的事件</strong></p>
<p>现在有这样一个Windows Application，它的界面上只有一个WebBrowser，显示一个本地的HTML文件作为界面。现在的问题是，所有逻辑都可以放在HTML文件里，唯独&ldquo;关闭&rdquo;按钮遇到了困难&mdash;&mdash;通常，Web页面是没有办法直接控制浏览器的，更不用说结束这个WinForm程序了。</p>
<p>但是，在.Net 2.0当中，&ldquo;由Windows Form响应Web页面的事件&rdquo;已经成为了现实。</p>
<p>在.Net 2.0中，整个HTML文档以及其包含的各个HTML元素，都和一个个HtmlDocument、HtmlElement之类的.Net对象对应。因此只要找到这个&ldquo;关闭&rdquo;按钮对应的HtmlElement对象，为其click事件添加Event Handler即可。</p>
<p>假设HTML源代码如下：</p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
&lt;body&gt;<br />
&lt;input type="button" id="btnClose" value="关闭" /&gt;<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>那么找出该按钮并为之添加Event Handler的代码如下：</p>
<div>
<pre class="prettyprint linenums">HtmlDocument htmlDoc = webBrowser.Document;<br />
HtmlElement btnElement = htmlDoc.All["btnClose"];<br />
if (btnElement != null)<br />
{<br />
    btnElement.click += new HtmlElementEventHandler(HtmlBtnClose_Click);<br />
}</pre>
</div>
<p>其中HtmlBtnClose_Click是按下Web按钮时的Event Handler。</p>
<p>很简单吧？那么稍稍高级一点的&mdash;&mdash;我们都知道一个HTML元素可能有很多各种各样的事件，而HtmlElement这个类只给出最常用、共通的几个。那么，如何响应其他事件呢？这也很简单，只需要调用HtmlElement的AttachEventHandler就可以了：</p>
<div>
<pre class="prettyprint linenums">btnElement.AttachEventHandler("onclick", new EventHandler(HtmlBtnClose_Click));<br />
//这一句等价于上面的btnElement.click += new HtmlElementEventHandler(HtmlBtnClose_Click); </pre>
</div>
<p>对于其他事件，把"onclick"换成该事件的名字就可以了。例如：</p>
<div>
<pre class="prettyprint linenums">formElement.AttachEventHandler("onsubmit", new EventHandler(HtmlForm_Submit));</pre>
</div>
<p><strong>Study Case 2：表单（form）的自动填写和提交&nbsp;<br /></strong>要使我们的WebBrowser具有自动填表、甚至自动提交的功能，并不困难。</p>
<p>假设有一个最简单的登录页面，输入用户名密码，点&ldquo;登录&rdquo;按钮即可登录。已知用户名输入框的id（或Name，下同）是username，密码输入框的id是password，&ldquo;登录&rdquo;按钮的id是submitbutton，那么我们只需要在webBrowser的DocumentCompleted事件中使用下面的代码即可：</p>
<div>
<pre class="prettyprint linenums">HtmlElement btnSubmit = webBrowser.Document.All["submitbutton"];<br />
HtmlElement tbUserid = webBrowser.Document.All["username"];<br />
HtmlElement tbPasswd = webBrowser.Document.All["password"];<br />
if (tbUserid == null || tbPasswd == null || btnSubmit == null)<br />
return;<br />
tbUserid.SetAttribute("value", "smalldust");<br />
tbPasswd.SetAttribute("value", "");<br />
btnSubmit.InvokeMember("click");</pre>
</div>
<p>这里我们用SetAttribute来设置文本框的&ldquo;value&rdquo;属性，用InvokeMember来调用了按钮的&ldquo;click&rdquo;方法。因为不同的Html元素，其拥有的属性和方法也不尽相同，所以.Net 2.0提供了统一的HtmlElement来概括各种Html元素的同时，提供了这两个方法以调用元素特有的功能。</p>
<p>※关于表单的提交，的确还有另一种方法就是获取form元素而不是button，并用form元素的submit方法：</p>
<div>
<pre class="prettyprint linenums">HtmlElement formLogin = webBrowser.Document.Forms["loginForm"];<br />
//&hellip;&hellip;<br />
formLogin.InvokeMember("submit");</pre>
</div>
<p>本文之所以没有推荐这种方法，是因为现在的网页，很多都在submit按钮上添加onclick事件，以对提交的内容做最基本的验证。如果直接使用form的submit方法，这些验证代码就得不到执行，有可能会引起错误。</p>
<p><strong>Study Case 3：查找并选择文本&nbsp;<br /></strong>这次我们希望实现一个和IE一模一样的查找功能，以对Web页面内的文字进行查找。</p>
<p>文本查找要借助于TextRange对象的findText方法。但是，.Net里并没有这个对象。这是因为，.Net 2.0提供的HtmlDocument，HtmlWindow，HtmlElement等类，只不过是对原有mshtml这个COM组件的不完整封装，只提供了mshtml的部分功能。所以许多时候，我们仍旧要借助mshtml来实现我们需要的功能。好在这些.Net类都提供了DomDocument这个属性，使得我们很容易把.Net对象转换为COM对象使用。下面的代码演示了如何查找Web页面的文本。（需要添加mshtml的引用，并加上using mshtml;）</p>
<div>
<pre class="prettyprint linenums">public partial class SearchDemo : Form<br />
{<br />
    // 建立一个查找用的TextRange（IHTMLTxtRange接口）<br />
    private IHTMLTxtRange searchRange = null;<br />
    public SearchDemo()<br />
    {<br />
        InitializeComponent();<br />
    }<br />
    private void btnSearch_Click(object sender, EventArgs e)<br />
    {<br />
        // Document的DomDocument属性，就是该对象内部的COM对象。<br />
        IHTMLDocument2 document = (IHTMLDocument2)webBrowser.Document.DomDocument;<br />
        string keyword = txtKeyword.Text.Trim();<br />
        if (keyword == "")<br />
            return;<br />
        // IE的查找逻辑就是，如果有选区，就从当前选区开头+1字符处开始查找；没有的话就从页面最初开始查找。<br />
        // 这个逻辑其实是有点不大恰当的，我们这里不用管，和IE一致即可。<br />
        if (document.selection.type.ToLower() != "none")<br />
        {<br />
            searchRange = (IHTMLTxtRange)document.selection.createRange();<br />
            searchRange.collapse(true);<br />
            searchRange.moveStart("character", );<br />
        }<br />
        else<br />
        {<br />
            IHTMLBodyElement body = (IHTMLBodyElement)document.body;<br />
            searchRange = (IHTMLTxtRange)body.createTextRange();<br />
        }<br />
        // 如果找到了，就选取（高亮显示）该关键字；否则弹出消息。<br />
        if (searchRange.findText(keyword, , ))<br />
        {<br />
            searchRange.select();<br />
        }<br />
        else<br />
        {<br />
            MessageBox.Show("已搜索到文档结尾。");<br />
        }<br />
    }<br />
}</pre>
</div>
<p>http://www.sosuo8.com/article-2011/webbrowser-control-form-automatically-fill-and-submit.htm</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96lozy9.html">DEV word文档转换为pdf文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93ggvr8.html">C&num;各种文件操作的代码与注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zpv2v9.html">poj 2503&colon;Babelfish（字典树，经典题，字典翻译）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kz3er8.html">一个java的DES加密解密类转换成C&num;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8epzdx9.html">Vue&period;2&period;0&period;5-生产环境部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1m6p69.html">解决NetworkOnMainThreadException</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxno5z08.html">使用ncc分析代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn15myg8.html">TP第2个项目总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1xgzx9.html">&lbrack;转载&rsqb;Asp&period;net MVC2 与 MVC3 路由调试好帮手RouteDebug 与 RouteDebugger</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4xzpq.html">Qt自定义控件&lpar;插件&rpar;并添加到QtDesigher</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yvvx0q.html">ZOJ3527</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2p7j9.html">LED限流电阻的大小计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnewr9.html">005&period;数组、for、foreach</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ygwmn8.html">【广告】win10 uwp 水印图床 含代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg2nrr8.html">序列操作 BZOJ2962 线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwwm2z8.html">program--历史故事</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7el11g9.html">51nod 1243 排船的问题（二分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2xm49.html">C&plus;&plus; 11 中的 Lambda 表达式的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvewpd19.html">从0开始配置ubuntu深度学习系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpvgez9.html">ubuntu 下出现E&colon; Sub-process &sol;usr&sol;bin&sol;dpkg returned an error code</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mn161q.html">webSphere集群部署主要步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlm53569.html">JS获取非行间样式及兼容问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ynok0q.html">DNA RNA</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1ovnz9.html">《服务器的追踪与审计》RHEL6</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd0e4d8.html">PHP利用socket&lowbar;bind函数切换IP地址采集数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd0jze8.html">android 线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o56pj9.html">通过百度地图API定位--第三方开源--百度地图（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjx1dd9.html">Eclipse使用ButterKnife前，需要的配置步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm5m479.html">C&num;二维数组及其本质（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1y1wg8.html">mysql学习笔记之基础篇</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
